.Const
ECDrvName                Equ    <"ECIDTDriver">


.Data?
TMP_Buffer               DB     MAX_PATH Dup (?)
Renglon                  DB     MAX_PATH Dup (?)
TABs                     DD     20 Dup (?)

Vector                   DD     ?

KIDTENTRY Struct
 Offset_                 DW     ?
 Selector                DW     ?
 Access                  DW     ?
 ExtendedOffset          DW     ?
KIDTENTRY EndS

.Data
hList                 HANDLE    0
hFile                 HANDLE    0
NullStr                  DD     0
TAB                      DB     09, 00, 00

.Code

ECIDTDrvTestProcedure Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
    .If uMsg == WM_CREATE

    .ElseIf uMsg == ECM_AFTERCREATE
        Invoke GetWindowItem, hWnd, IDC_ECIDTDRVTEST_LIST1
        Mov hList, Eax
        Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
           Mov Eax, Offset TABs
           Mov DWord Ptr [Eax], 20
           Mov DWord Ptr [Eax + 4], 50
           Mov DWord Ptr [Eax + 8], 110
           Mov DWord Ptr [Eax + 12], 130
           Mov DWord Ptr [Eax + 16], 150
           Mov DWord Ptr [Eax + 20], 180
           Mov DWord Ptr [Eax + 24], 240
        Invoke SendMessage, hList, LB_SETTABSTOPS, 7, Addr TABs
        ;--
        Call Load_ECPDrv
        Call Open_File
        ;--
    .ElseIf uMsg == WM_CLOSE
        ;--
        Call Close_file
        Call UnLoad_ECPDrv
        ;--
        Invoke IsModal, hWnd
        .If Eax
            Invoke EndModal, hWnd, IDCANCEL
            Return TRUE
        .EndIf
    .ElseIf uMsg == WM_COMMAND
         LoWord wParam
         .If Ax == IDC_ECIDTDRVTEST_BUTTON1
            HiWord wParam
            .If Ax == BN_CLICKED
               Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
               Call Read_File
               Return TRUE
            .EndIf
         .EndIf
    .EndIf
    Return FALSE
ECIDTDrvTestProcedure EndP

ECIDTDrvTestList1 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
    Return FALSE
ECIDTDrvTestList1 EndP

ECIDTDrvTestButton1 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
    Return FALSE
ECIDTDrvTestButton1 EndP

Load_ECPDrv Proc Private
       Local hSCManager:HANDLE, hService:HANDLE
       Local acDriverPath[MAX_PATH]:CHAR

    Invoke OpenSCManager, NULL, NULL, SC_MANAGER_CREATE_SERVICE
    .If Eax != NULL
        Mov hSCManager, Eax
        Invoke GetFullPathName, TextAddr(ECDrvName, ".sys"), SizeOf acDriverPath, Addr acDriverPath, NULL
        Invoke CreateService, hSCManager, TextAddr(ECDrvName), TextAddr("EC SYS Driver"), \
                       SERVICE_START + DELETE, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, \
                       SERVICE_ERROR_IGNORE, Addr acDriverPath, NULL, NULL, NULL, NULL, NULL
        .If Eax != NULL
            Mov hService, Eax
            Invoke StartService, hService, 0, NULL
            Invoke CloseServiceHandle, hService
        .Else
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Create Service Err")
        .EndIf
        Invoke CloseServiceHandle, hSCManager
    .Else
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open SCManager Err")
    .EndIf
    Ret
Load_ECPDrv EndP

UnLoad_ECPDrv Proc Private
       Local hSCManager:HANDLE, hService:HANDLE
       Local sService:SERVICE_STATUS

    Invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS
    .If Eax != NULL
        Mov hSCManager, Eax
       Invoke OpenService, hSCManager, TextAddr(ECDrvName), SERVICE_ALL_ACCESS
       .If Eax != NULL
          Mov hService, Eax
            Invoke ControlService, hService, SERVICE_CONTROL_STOP, Addr sService
            Invoke DeleteService, hService
            Invoke CloseServiceHandle, hService
        .Else
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open Service Err")
        .EndIf
        Invoke CloseServiceHandle, hSCManager
    .Else
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open SCManager Err")
    .EndIf
    ;--
    Ret
UnLoad_ECPDrv EndP

Open_File Proc Private
     .If hFile != 0
         Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open File Err")
         Ret
     .EndIf
     Invoke CreateFile, TextAddr("\\.\", ECDrvName), GENERIC_READ Or GENERIC_WRITE, \
            FILE_SHARE_READ Or FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
     .If Eax != INVALID_HANDLE_VALUE
          Mov hFile, Eax
     .Else
         Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Create File Err")
     .EndIf
    Ret
Open_File EndP

Close_file Proc Private
    .If hFile != 0
          Invoke CloseHandle, hFile
          Mov hFile, 0
    .EndIf
    Ret
Close_file EndP

Read_File Proc Private Uses Ebx Ecx Esi
                        Local InBufferPtr:DWord
                        Local InBufferLen:DWord
                        Local BRet:DWord
    Mov InBufferLen, 4096
    Mov InBufferPtr, 0
    Mov BRet, 0
    Invoke GlobalAlloc, GPTR, InBufferLen
    .If Eax != 0
      Mov InBufferPtr, Eax
      Invoke ReadFile, hFile, InBufferPtr, InBufferLen, Addr BRet, NULL
      ;--
           Mov Esi, InBufferPtr
           Mov Eax, [Esi]
           Mov Ecx, [Esi + 4]
           Invoke wsprintf, Addr Renglon, TextAddr("Base: %08X  Limit:  %08X"), Eax, Ecx
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr Renglon
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("INT", 09, "SELEC", 09, "OFFSET", 09, "DPL", 09, "P", 09, "D", 09, "TYPE", 09, "DESCRIPTION")
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
        .If BRet > 0
           Mov Esi, InBufferPtr
           Mov Ebx, [Esi + 4]    ; Idt.Limit
           ; The IDT limit is always be one less than an integral multiple of eight (that is, 8N - 1).
           Inc Ebx
           Shr Ebx, 3     ; / sizeof KIDTENTRY
           Mov Vector, 0
           Add Esi, SizeOf DWord * 2
           Assume Esi:Ptr KIDTENTRY
          .While Ebx
             Invoke RtlZeroMemory, Addr Renglon, SizeOf Renglon
             ; Int #
             Invoke wsprintf, Addr TMP_Buffer, TextAddr("%02X  "), Vector
             Invoke lstrcat, Addr Renglon, Addr TMP_Buffer
             ; Selector
             Movzx Ecx, [Esi].Selector
             Invoke wsprintf, Addr TMP_Buffer, TextAddr("%s %04X:"), Addr TAB, Ecx
             Invoke lstrcat, Addr Renglon, Addr TMP_Buffer
             ; Offset
             Mov Cx, [Esi].ExtendedOffset
             Shl Ecx, 16
             Mov Cx, [Esi].Offset_
             Invoke wsprintf, Addr TMP_Buffer, TextAddr("%s %08X   "), Addr TAB, Ecx
             Invoke lstrcat, Addr Renglon, Addr TMP_Buffer
             ; DPL
             Movzx Ecx, [Esi].Access
             Shr Ecx, 13
             And Ecx, 011Y
             Invoke wsprintf, Addr TMP_Buffer, TextAddr("%s%d"), Addr TAB, Ecx
             Invoke lstrcat, Addr Renglon, Addr TMP_Buffer
             ; Segment present flag
             Movzx Ecx, [Esi].Access
             Shr Ecx, 15
             .If Ecx == 1
                Mov Eax, TextAddr(09, "P")
             .Else
                Mov Eax, TextAddr(09, "NP")
             .EndIf
             Invoke lstrcat, Addr Renglon, Eax
             ; Size of gate
             Movzx Ecx, [Esi].Access
             Shr Ecx, 8
             Mov Eax, Ecx
             And Eax, 0111Y
             .If Eax != 0101Y   ; D flag is not valid for Task Gate
               Shr Ecx, 3
               And Ecx, 01Y     ; mask D flag
               .If Ecx == 1
                  Mov Eax, TextAddr(09, "32 bits")
               .Else
                  Mov Eax, TextAddr(09, "16 bits")
               .EndIf
             .Else
                  Mov Eax, TextAddr(09, "?")
             .EndIf
             Invoke lstrcat, Addr Renglon, Eax
             ; Descriptor Type
             Movzx Ecx, [Esi].Access
             Shr Ecx, 8
             And Ecx, 0111Y
             .If Ecx == 0101Y
                Mov Eax, TextAddr(09, "Task Gate")
             .ElseIf Ecx == 0110Y
                Mov Eax, TextAddr(09, "Interrupt Gate")
             .ElseIf Ecx == 0111Y
                Mov Eax, TextAddr(09, "Trap Gate")
             .Else
                 Mov Eax, TextAddr(09, " ")
             .EndIf
             Invoke lstrcat, Addr Renglon, Eax
             Invoke lstrcat, Addr Renglon, Addr TAB
             ; Description
             Mov Ecx, Vector
             .If Ecx == 0
                Mov Eax, TextAddr("Err.Divide Error")
             .ElseIf Ecx == 1
                Mov Eax, TextAddr("Fault/Trap Debug")
             .ElseIf Ecx == 2
                Mov Eax, TextAddr("NMI Interrupt")
             .ElseIf Ecx == 3
                Mov Eax, TextAddr("Trap Breakpoint")
             .ElseIf Ecx == 4
                Mov Eax, TextAddr("Trap Overflow")
             .ElseIf Ecx == 5
                Mov Eax, TextAddr("Err. BOUND Range Exceeded")
             .ElseIf Ecx == 6
                Mov Eax, TextAddr("Err. Invalid Opcode")
             .ElseIf Ecx == 7
               Mov Eax, TextAddr("Err. No Math Coprocessor")
             .ElseIf Ecx == 8
               Mov Eax, TextAddr("Err. Double Fault")
             .ElseIf Ecx == 9
               Mov Eax, TextAddr("Coprocessor Segment Overrun.")
             .ElseIf Ecx == 10
               Mov Eax, TextAddr("Err. Invalid TSS")
             .ElseIf Ecx == 11
               Mov Eax, TextAddr("Err. Segment Not Present")
             .ElseIf Ecx == 12
               Mov Eax, TextAddr("Err. Stack-Segment Fault")
             .ElseIf Ecx == 13
               Mov Eax, TextAddr("Err. General Protection")
             .ElseIf Ecx == 14
               Mov Eax, TextAddr("Err. Page Fault")
             .ElseIf Ecx == 15
               Mov Eax, TextAddr("Intel reserved")
             .ElseIf Ecx == 16
               Mov Eax, TextAddr("Err. FPU Floating-Point")
             .ElseIf Ecx == 17
               Mov Eax, TextAddr("Err. Alignment Check")
             .ElseIf Ecx == 18
               Mov Eax, TextAddr("Abort Machine Check")
             .ElseIf Ecx == 19
               Mov Eax, TextAddr("SIMD Floating-Point Exception")
             .Else
               Mov Eax, TextAddr(" ")
               .If Ecx >= 20 && Ecx <= 31
                  Mov Eax, TextAddr("Intel Do not use")
               .EndIf
               .If Ecx >= 32
                  Mov Eax, TextAddr("User Defined")
               .EndIf
             .EndIf
             Invoke lstrcat, Addr Renglon, Eax
             Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr Renglon

             Add Esi, SizeOf KIDTENTRY
             Inc Vector
             Dec Ebx
          .EndW
          Assume Esi:Nothing
      .EndIf
      ;--
      Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
      Invoke wsprintf, Addr TMP_Buffer, TextAddr("Readed Ret: %s%u bytes"), Addr TAB, BRet
      Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
      ;--
      Invoke GlobalFree, InBufferPtr
    .Else
      Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Alloc Mem Err.")
    .EndIf
    Ret
Read_File EndP
